import * as i4 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i0 from '@angular/core';
import { NgModule, Injectable, Input, ViewEncapsulation, Component, EventEmitter, inject, Output } from '@angular/core';
import * as i1 from '@skyux/errors';
import { SkyErrorModule } from '@skyux/errors';
import * as i2 from '@skyux/forms';
import { SkyFileAttachmentsModule, SkyFileSizePipe } from '@skyux/forms';
import * as i3 from '@skyux/theme';
import { SkyThemeModule } from '@skyux/theme';
import * as i3$1 from '@skyux/i18n';
import { SkyLibResourcesService, SkyI18nModule } from '@skyux/i18n';
import { SkyDefaultInputProvider } from '@skyux/core';

/* istanbul ignore file */
/**
 * NOTICE: DO NOT MODIFY THIS FILE!
 * The contents of this file were automatically generated by
 * the 'ng generate @skyux/i18n:lib-resources-module lib/modules/shared/sky-avatar' schematic.
 * To update this file, simply rerun the command.
 */
const RESOURCES = {
    'EN-US': {
        skyux_avatar_error_not_image_description: {
            message: 'Please choose a file that is a valid image.',
        },
        skyux_avatar_error_not_image_title: { message: 'File is not an image.' },
        skyux_avatar_error_too_large_description: {
            message: 'Please choose an image that is less than {0}.',
        },
        skyux_avatar_error_too_large_title: { message: 'File is too large.' },
        skyux_avatar_errormodal_ok: { message: 'OK' },
        skyux_avatar_inner_description: { message: 'Profile picture of {0}' },
        skyux_avatar_upload_change_aria_label: {
            message: 'Change profile photo of {0}. Drag a file here or click to browse.',
        },
        skyux_avatar_upload_new_aria_label: {
            message: 'Add profile photo of {0}. Drag a file here or click to browse.',
        },
    },
    'FR-CA': {
        skyux_avatar_error_not_image_description: {
            message: 'Veuillez choisir un fichier qui soit une image valide.',
        },
        skyux_avatar_error_not_image_title: {
            message: 'Le fichier n’est pas une image.',
        },
        skyux_avatar_error_too_large_description: {
            message: 'Veuillez choisir une image de moins de {0}.',
        },
        skyux_avatar_error_too_large_title: {
            message: 'Le fichier est trop gros.',
        },
        skyux_avatar_errormodal_ok: { message: 'OK' },
        skyux_avatar_inner_description: { message: 'Photo de profil de {0}' },
        skyux_avatar_upload_change_aria_label: {
            message: 'Modifier la photo de profil de {0}. Faites glisser un fichier ici ou cliquez pour naviguer.',
        },
        skyux_avatar_upload_new_aria_label: {
            message: 'Ajoutez une photo de profil pour {0}. Faites glisser un fichier ici ou cliquez pour naviguer.',
        },
    },
};
SkyLibResourcesService.addResources(RESOURCES);
/**
 * Import into any component library module that needs to use resource strings.
 */
class SkyAvatarResourcesModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: SkyAvatarResourcesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "19.2.14", ngImport: i0, type: SkyAvatarResourcesModule, exports: [SkyI18nModule] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: SkyAvatarResourcesModule, imports: [SkyI18nModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: SkyAvatarResourcesModule, decorators: [{
            type: NgModule,
            args: [{
                    exports: [SkyI18nModule],
                }]
        }] });

/**
 * @internal
 */
class SkyAvatarAdapterService {
    #blobUrl;
    updateImage(elementRef, src) {
        this.#revokeBlobUrl();
        const el = elementRef.nativeElement;
        /*istanbul ignore else */
        if (el) {
            const imageEl = el.querySelector('.sky-avatar-image');
            /*istanbul ignore else */
            if (imageEl) {
                let url = src;
                if (src instanceof File || src instanceof Blob) {
                    url = this.#createBlobUrl(src);
                }
                // Notice the quotes inside the `url` function. This ensures proper url escaping.
                imageEl.style.backgroundImage = 'url("' + url + '")';
            }
        }
    }
    destroy() {
        this.#revokeBlobUrl();
    }
    #createBlobUrl(src) {
        const url = URL.createObjectURL(src);
        // Keep the last blob URL around so we can revoke it later.
        // https://developer.mozilla.org/en-US/docs/Web/API/URL/revokeObjectURL
        this.#blobUrl = url;
        return url;
    }
    #revokeBlobUrl() {
        if (this.#blobUrl) {
            URL.revokeObjectURL(this.#blobUrl);
            this.#blobUrl = undefined;
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: SkyAvatarAdapterService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: SkyAvatarAdapterService }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: SkyAvatarAdapterService, decorators: [{
            type: Injectable
        }] });

/**
 * @internal
 */
class SkyAvatarInnerComponent {
    get src() {
        return this.#_src;
    }
    set src(value) {
        this.#_src = value;
        this.#updateImage();
    }
    get name() {
        return this.#_name;
    }
    set name(value) {
        this.#_name = value;
        if (value) {
            // Generate a unique-ish color based on the record name.  This is deterministic
            // so that a given name will always generate the same color.
            const seed = value.charCodeAt(0) + value.charCodeAt(value.length - 1) + value.length;
            this.#colorIndex = Math.abs(seed % 7);
        }
        else {
            this.#colorIndex = 0;
        }
    }
    #viewInitialized;
    #_src;
    #_name;
    #elementRef;
    #adapter;
    constructor(elementRef, adapter) {
        this.size = 'large';
        this.#viewInitialized = false;
        this.#colorIndex = 0;
        this.#elementRef = elementRef;
        this.#adapter = adapter;
    }
    get initials() {
        let initials;
        if (this.name) {
            const nameSplit = this.name.split(' ');
            initials = getInitial(nameSplit[0]);
            if (nameSplit.length > 1) {
                initials += getInitial(nameSplit[nameSplit.length - 1]);
            }
        }
        return initials;
    }
    get colorIndex() {
        return this.#colorIndex;
    }
    #colorIndex;
    ngAfterViewInit() {
        this.#viewInitialized = true;
        this.#updateImage();
    }
    ngOnDestroy() {
        this.#adapter.destroy();
    }
    #updateImage() {
        if (this.#viewInitialized && this.src) {
            this.#adapter.updateImage(this.#elementRef, this.src);
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: SkyAvatarInnerComponent, deps: [{ token: i0.ElementRef }, { token: SkyAvatarAdapterService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.2.14", type: SkyAvatarInnerComponent, isStandalone: false, selector: "sky-avatar-inner", inputs: { src: "src", name: "name", size: "size" }, providers: [SkyAvatarAdapterService], ngImport: i0, template: "<div\n  class=\"sky-elevation-1 sky-avatar-wrapper\"\n  [ngClass]=\"'sky-avatar-wrapper-size-' + size\"\n>\n  <div class=\"sky-avatar-image\" [hidden]=\"!src\"></div>\n  @if (src) {\n    <div class=\"sky-screen-reader-only\">\n      {{ 'skyux_avatar_inner_description' | skyLibResources: name }}\n    </div>\n  }\n  <div\n    class=\"sky-avatar-initials\"\n    [hidden]=\"src || !name\"\n    [ngClass]=\"'sky-avatar-colors-' + (colorIndex + 1)\"\n  >\n    @if (size === 'small') {\n      <div\n        class=\"sky-avatar-initials-inner\"\n        [skyThemeClass]=\"{\n          'sky-font-body-sm': 'modern'\n        }\"\n      >\n        {{ initials }}\n      </div>\n    } @else if (size === 'medium') {\n      <div\n        class=\"sky-avatar-initials-inner\"\n        [skyThemeClass]=\"{\n          'sky-font-display-3': 'modern'\n        }\"\n      >\n        {{ initials }}\n      </div>\n    } @else if (size === 'large') {\n      <div\n        class=\"sky-avatar-initials-inner\"\n        [skyThemeClass]=\"{\n          'sky-font-display-2': 'modern'\n        }\"\n      >\n        {{ initials }}\n      </div>\n    }\n  </div>\n</div>\n", styles: [".sky-avatar:not(.sky-theme-modern *){--sky-override-avatar-initials-border-radius: initial;--sky-override-avatar-initials-font-size: 50px;--sky-override-avatar-initials-font-size-md: 32.5px;--sky-override-avatar-initials-font-size-sm: 16px;--sky-override-avatar-initials-height: 100px;--sky-override-avatar-initials-height-md: 65px;--sky-override-avatar-initials-height-sm: 32px;--sky-override-avatar-initials-width: 100px;--sky-override-avatar-initials-width-md: 65px;--sky-override-avatar-initials-width-sm: 32px;--sky-override-avatar-wrapper-background-color: transparent;--sky-override-avatar-wrapper-border: solid 2px transparent;--sky-override-avatar-wrapper-border-radius: 50%;--sky-override-avatar-wrapper-drop-accept-border-color: #72bf44;--sky-override-avatar-wrapper-drop-border-width: 2px;--sky-override-avatar-wrapper-drop-border-active: solid 2px transparent;--sky-override-avatar-wrapper-drop-border-hover: solid 2px transparent;--sky-override-avatar-wrapper-drop-box-shadow-focus: 0 0 5px 0 rgba(0, 0, 0, .3);--sky-override-avatar-wrapper-drop-reject-border-color: #ef4044;--sky-override-avatar-wrapper-height: 104px;--sky-override-avatar-wrapper-height-md: 69px;--sky-override-avatar-wrapper-height-sm: 36px;--sky-override-avatar-wrapper-left: -2px;--sky-override-avatar-wrapper-padding: 0;--sky-override-avatar-wrapper-padding-md: 0;--sky-override-avatar-wrapper-padding-sm: 0;--sky-override-avatar-wrapper-top: -2px;--sky-override-avatar-wrapper-width: 104px;--sky-override-avatar-wrapper-width-md: 69px;--sky-override-avatar-wrapper-width-sm: 36px}.sky-theme-modern:not(.sky-theme-brand-base) .sky-avatar{--sky-override-avatar-wrapper-drop-border-width: 2px;--sky-override-avatar-wrapper-drop-box-shadow-focus: var( --sky-elevation-focus )}.sky-avatar-colors-1{background-color:var(--sky-category-color-light-blue)}.sky-avatar-colors-2{background-color:var(--sky-category-color-teal)}.sky-avatar-colors-3{background-color:var(--sky-category-color-purple)}.sky-avatar-colors-4{background-color:var(--sky-category-color-orange)}.sky-avatar-colors-5{background-color:var(--sky-category-color-blue)}.sky-avatar-colors-6{background-color:var(--sky-category-color-yellow)}.sky-avatar-colors-7{background-color:var(--sky-category-color-red)}.sky-avatar-wrapper{height:var(--sky-override-avatar-wrapper-height, var(--sky-size-avatar-l));width:var(--sky-override-avatar-wrapper-width, var(--sky-size-avatar-l));background-color:var(--sky-override-avatar-wrapper-background-color, var(--sky-color-background-thumbnail_matte));padding:var(--sky-override-avatar-wrapper-padding, var(--sky-space-inset-thumbnail_matte-l));border:var(--sky-override-avatar-wrapper-border, none);border-radius:var(--sky-override-avatar-wrapper-border-radius, var(--sky-border-radius-round));overflow:hidden;position:relative;top:var(--sky-override-avatar-wrapper-top, 0);left:var(--sky-override-avatar-wrapper-left, 0)}.sky-avatar-image,.sky-avatar-initials{height:var(--sky-override-avatar-initials-height, calc(var(--sky-size-avatar-l) - var(--sky-space-inset-thumbnail_matte-l) * 2));width:var(--sky-override-avatar-initials-width, calc(var(--sky-size-avatar-l) - var(--sky-space-inset-thumbnail_matte-l) * 2));background-position:50%;background-size:cover;border-radius:var(--sky-override-avatar-initials-border-radius, var(--sky-border-radius-round));display:flex;align-items:center;justify-content:center}.sky-avatar-initials{font-size:var(--sky-override-avatar-initials-font-size, initial)}.sky-avatar-initials-inner{color:var(--sky-text-color-default);cursor:default;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none}.sky-avatar-wrapper-size-medium{height:var(--sky-override-avatar-wrapper-height-md, var(--sky-size-avatar-m));width:var(--sky-override-avatar-wrapper-width-md, var(--sky-size-avatar-m));padding:var(--sky-override-avatar-wrapper-padding-md, var(--sky-space-inset-thumbnail_matte-m))}.sky-avatar-wrapper-size-medium .sky-avatar-image,.sky-avatar-wrapper-size-medium .sky-avatar-initials{height:var(--sky-override-avatar-initials-height-md, calc(var(--sky-size-avatar-m) - var(--sky-space-inset-thumbnail_matte-m) * 2));width:var(--sky-override-avatar-initials-width-md, calc(var(--sky-size-avatar-m) - var(--sky-space-inset-thumbnail_matte-m) * 2))}.sky-avatar-wrapper-size-medium .sky-avatar-initials{font-size:var(--sky-override-avatar-initials-font-size-md, initial)}.sky-avatar-wrapper-size-small{height:var(--sky-override-avatar-wrapper-height-sm, var(--sky-size-avatar-s));width:var(--sky-override-avatar-wrapper-width-sm, var(--sky-size-avatar-s));padding:var(--sky-override-avatar-wrapper-padding-sm, var(--sky-space-inset-thumbnail_matte-s))}.sky-avatar-wrapper-size-small .sky-avatar-image,.sky-avatar-wrapper-size-small .sky-avatar-initials{height:var(--sky-override-avatar-initials-height-sm, calc(var(--sky-size-avatar-s) - var(--sky-space-inset-thumbnail_matte-s) * 2));width:var(--sky-override-avatar-initials-width-sm, calc(var(--sky-size-avatar-s) - var(--sky-space-inset-thumbnail_matte-s) * 2))}.sky-avatar-wrapper-size-small .sky-avatar-initials{font-size:var(--sky-override-avatar-initials-font-size-sm, initial)}.sky-file-drop .sky-avatar-wrapper{cursor:pointer}.sky-file-drop-accept .sky-avatar-wrapper,.sky-file-drop-reject .sky-avatar-wrapper{border-style:dashed}.sky-file-drop-accept .sky-avatar-wrapper{border-color:var(--sky-override-avatar-wrapper-drop-accept-border-color, var(--sky-color-border-success))}.sky-file-drop-reject .sky-avatar-wrapper{border-color:var(--sky-override-avatar-wrapper-drop-reject-border-color, var(--sky-color-border-danger))}.sky-file-drop-accept .sky-avatar-wrapper,.sky-file-drop-reject .sky-avatar-wrapper{border-width:var(--sky-override-avatar-wrapper-drop-border-width, var(--sky-border-width-input-hover));padding:calc(var(--sky-override-avatar-wrapper-padding, var(--sky-space-inset-thumbnail_matte-l)) - var(--sky-override-avatar-wrapper-drop-border-width, var(--sky-border-width-input-hover)))}.sky-file-drop-accept .sky-avatar-wrapper-size-medium,.sky-file-drop-reject .sky-avatar-wrapper-size-medium{padding:calc(var(--sky-override-avatar-wrapper-padding-md, var(--sky-space-inset-thumbnail_matte-m)) - var(--sky-override-avatar-wrapper-drop-border-width, var(--sky-border-width-input-hover)))}.sky-file-drop-accept .sky-avatar-wrapper-size-small,.sky-file-drop-reject .sky-avatar-wrapper-size-small{padding:calc(var(--sky-override-avatar-wrapper-padding-sm, var(--sky-space-inset-thumbnail_matte-s)) - var(--sky-override-avatar-wrapper-drop-border-width, var(--sky-border-width-input-hover)))}sky-file-drop:hover .sky-avatar-wrapper{border:var(--sky-override-avatar-wrapper-drop-border-hover, var(--sky-border-width-input-hover) solid var(--sky-color-border-input-hover));padding:calc(var(--sky-override-avatar-wrapper-padding, var(--sky-space-inset-thumbnail_matte-l)) - var(--sky-border-width-input-hover))}sky-file-drop:hover .sky-avatar-wrapper.sky-avatar-wrapper-size-medium{padding:calc(var(--sky-override-avatar-wrapper-padding-md, var(--sky-space-inset-thumbnail_matte-m)) - var(--sky-border-width-input-hover))}sky-file-drop:hover .sky-avatar-wrapper.sky-avatar-wrapper-size-small{padding:calc(var(--sky-override-avatar-wrapper-padding-sm, var(--sky-space-inset-thumbnail_matte-s)) - var(--sky-border-width-input-hover))}sky-file-drop:active .sky-avatar-wrapper,sky-file-drop:focus-within .sky-avatar-wrapper{border:var(--sky-override-avatar-wrapper-drop-border-active, var(--sky-border-width-input-active) solid var(--sky-color-border-input-active));padding:calc(var(--sky-override-avatar-wrapper-padding, var(--sky-space-inset-thumbnail_matte-l)) - var(--sky-border-width-input-active))}sky-file-drop:active .sky-avatar-wrapper.sky-avatar-wrapper-size-medium,sky-file-drop:focus-within .sky-avatar-wrapper.sky-avatar-wrapper-size-medium{padding:calc(var(--sky-override-avatar-wrapper-padding-md, var(--sky-space-inset-thumbnail_matte-m)) - var(--sky-border-width-input-active))}sky-file-drop:active .sky-avatar-wrapper.sky-avatar-wrapper-size-small,sky-file-drop:focus-within .sky-avatar-wrapper.sky-avatar-wrapper-size-small{padding:calc(var(--sky-override-avatar-wrapper-padding-sm, var(--sky-space-inset-thumbnail_matte-s)) - var(--sky-border-width-input-active))}sky-file-drop:focus-within:not(:active) .sky-avatar-wrapper{box-shadow:var(--sky-override-avatar-wrapper-drop-box-shadow-focus, none)}\n"], dependencies: [{ kind: "directive", type: i4.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i3.λ2, selector: "[skyThemeClass]", inputs: ["class", "skyThemeClass"] }, { kind: "pipe", type: i3$1.SkyLibResourcesPipe, name: "skyLibResources" }], encapsulation: i0.ViewEncapsulation.None }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: SkyAvatarInnerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sky-avatar-inner', providers: [SkyAvatarAdapterService], encapsulation: ViewEncapsulation.None, standalone: false, template: "<div\n  class=\"sky-elevation-1 sky-avatar-wrapper\"\n  [ngClass]=\"'sky-avatar-wrapper-size-' + size\"\n>\n  <div class=\"sky-avatar-image\" [hidden]=\"!src\"></div>\n  @if (src) {\n    <div class=\"sky-screen-reader-only\">\n      {{ 'skyux_avatar_inner_description' | skyLibResources: name }}\n    </div>\n  }\n  <div\n    class=\"sky-avatar-initials\"\n    [hidden]=\"src || !name\"\n    [ngClass]=\"'sky-avatar-colors-' + (colorIndex + 1)\"\n  >\n    @if (size === 'small') {\n      <div\n        class=\"sky-avatar-initials-inner\"\n        [skyThemeClass]=\"{\n          'sky-font-body-sm': 'modern'\n        }\"\n      >\n        {{ initials }}\n      </div>\n    } @else if (size === 'medium') {\n      <div\n        class=\"sky-avatar-initials-inner\"\n        [skyThemeClass]=\"{\n          'sky-font-display-3': 'modern'\n        }\"\n      >\n        {{ initials }}\n      </div>\n    } @else if (size === 'large') {\n      <div\n        class=\"sky-avatar-initials-inner\"\n        [skyThemeClass]=\"{\n          'sky-font-display-2': 'modern'\n        }\"\n      >\n        {{ initials }}\n      </div>\n    }\n  </div>\n</div>\n", styles: [".sky-avatar:not(.sky-theme-modern *){--sky-override-avatar-initials-border-radius: initial;--sky-override-avatar-initials-font-size: 50px;--sky-override-avatar-initials-font-size-md: 32.5px;--sky-override-avatar-initials-font-size-sm: 16px;--sky-override-avatar-initials-height: 100px;--sky-override-avatar-initials-height-md: 65px;--sky-override-avatar-initials-height-sm: 32px;--sky-override-avatar-initials-width: 100px;--sky-override-avatar-initials-width-md: 65px;--sky-override-avatar-initials-width-sm: 32px;--sky-override-avatar-wrapper-background-color: transparent;--sky-override-avatar-wrapper-border: solid 2px transparent;--sky-override-avatar-wrapper-border-radius: 50%;--sky-override-avatar-wrapper-drop-accept-border-color: #72bf44;--sky-override-avatar-wrapper-drop-border-width: 2px;--sky-override-avatar-wrapper-drop-border-active: solid 2px transparent;--sky-override-avatar-wrapper-drop-border-hover: solid 2px transparent;--sky-override-avatar-wrapper-drop-box-shadow-focus: 0 0 5px 0 rgba(0, 0, 0, .3);--sky-override-avatar-wrapper-drop-reject-border-color: #ef4044;--sky-override-avatar-wrapper-height: 104px;--sky-override-avatar-wrapper-height-md: 69px;--sky-override-avatar-wrapper-height-sm: 36px;--sky-override-avatar-wrapper-left: -2px;--sky-override-avatar-wrapper-padding: 0;--sky-override-avatar-wrapper-padding-md: 0;--sky-override-avatar-wrapper-padding-sm: 0;--sky-override-avatar-wrapper-top: -2px;--sky-override-avatar-wrapper-width: 104px;--sky-override-avatar-wrapper-width-md: 69px;--sky-override-avatar-wrapper-width-sm: 36px}.sky-theme-modern:not(.sky-theme-brand-base) .sky-avatar{--sky-override-avatar-wrapper-drop-border-width: 2px;--sky-override-avatar-wrapper-drop-box-shadow-focus: var( --sky-elevation-focus )}.sky-avatar-colors-1{background-color:var(--sky-category-color-light-blue)}.sky-avatar-colors-2{background-color:var(--sky-category-color-teal)}.sky-avatar-colors-3{background-color:var(--sky-category-color-purple)}.sky-avatar-colors-4{background-color:var(--sky-category-color-orange)}.sky-avatar-colors-5{background-color:var(--sky-category-color-blue)}.sky-avatar-colors-6{background-color:var(--sky-category-color-yellow)}.sky-avatar-colors-7{background-color:var(--sky-category-color-red)}.sky-avatar-wrapper{height:var(--sky-override-avatar-wrapper-height, var(--sky-size-avatar-l));width:var(--sky-override-avatar-wrapper-width, var(--sky-size-avatar-l));background-color:var(--sky-override-avatar-wrapper-background-color, var(--sky-color-background-thumbnail_matte));padding:var(--sky-override-avatar-wrapper-padding, var(--sky-space-inset-thumbnail_matte-l));border:var(--sky-override-avatar-wrapper-border, none);border-radius:var(--sky-override-avatar-wrapper-border-radius, var(--sky-border-radius-round));overflow:hidden;position:relative;top:var(--sky-override-avatar-wrapper-top, 0);left:var(--sky-override-avatar-wrapper-left, 0)}.sky-avatar-image,.sky-avatar-initials{height:var(--sky-override-avatar-initials-height, calc(var(--sky-size-avatar-l) - var(--sky-space-inset-thumbnail_matte-l) * 2));width:var(--sky-override-avatar-initials-width, calc(var(--sky-size-avatar-l) - var(--sky-space-inset-thumbnail_matte-l) * 2));background-position:50%;background-size:cover;border-radius:var(--sky-override-avatar-initials-border-radius, var(--sky-border-radius-round));display:flex;align-items:center;justify-content:center}.sky-avatar-initials{font-size:var(--sky-override-avatar-initials-font-size, initial)}.sky-avatar-initials-inner{color:var(--sky-text-color-default);cursor:default;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none}.sky-avatar-wrapper-size-medium{height:var(--sky-override-avatar-wrapper-height-md, var(--sky-size-avatar-m));width:var(--sky-override-avatar-wrapper-width-md, var(--sky-size-avatar-m));padding:var(--sky-override-avatar-wrapper-padding-md, var(--sky-space-inset-thumbnail_matte-m))}.sky-avatar-wrapper-size-medium .sky-avatar-image,.sky-avatar-wrapper-size-medium .sky-avatar-initials{height:var(--sky-override-avatar-initials-height-md, calc(var(--sky-size-avatar-m) - var(--sky-space-inset-thumbnail_matte-m) * 2));width:var(--sky-override-avatar-initials-width-md, calc(var(--sky-size-avatar-m) - var(--sky-space-inset-thumbnail_matte-m) * 2))}.sky-avatar-wrapper-size-medium .sky-avatar-initials{font-size:var(--sky-override-avatar-initials-font-size-md, initial)}.sky-avatar-wrapper-size-small{height:var(--sky-override-avatar-wrapper-height-sm, var(--sky-size-avatar-s));width:var(--sky-override-avatar-wrapper-width-sm, var(--sky-size-avatar-s));padding:var(--sky-override-avatar-wrapper-padding-sm, var(--sky-space-inset-thumbnail_matte-s))}.sky-avatar-wrapper-size-small .sky-avatar-image,.sky-avatar-wrapper-size-small .sky-avatar-initials{height:var(--sky-override-avatar-initials-height-sm, calc(var(--sky-size-avatar-s) - var(--sky-space-inset-thumbnail_matte-s) * 2));width:var(--sky-override-avatar-initials-width-sm, calc(var(--sky-size-avatar-s) - var(--sky-space-inset-thumbnail_matte-s) * 2))}.sky-avatar-wrapper-size-small .sky-avatar-initials{font-size:var(--sky-override-avatar-initials-font-size-sm, initial)}.sky-file-drop .sky-avatar-wrapper{cursor:pointer}.sky-file-drop-accept .sky-avatar-wrapper,.sky-file-drop-reject .sky-avatar-wrapper{border-style:dashed}.sky-file-drop-accept .sky-avatar-wrapper{border-color:var(--sky-override-avatar-wrapper-drop-accept-border-color, var(--sky-color-border-success))}.sky-file-drop-reject .sky-avatar-wrapper{border-color:var(--sky-override-avatar-wrapper-drop-reject-border-color, var(--sky-color-border-danger))}.sky-file-drop-accept .sky-avatar-wrapper,.sky-file-drop-reject .sky-avatar-wrapper{border-width:var(--sky-override-avatar-wrapper-drop-border-width, var(--sky-border-width-input-hover));padding:calc(var(--sky-override-avatar-wrapper-padding, var(--sky-space-inset-thumbnail_matte-l)) - var(--sky-override-avatar-wrapper-drop-border-width, var(--sky-border-width-input-hover)))}.sky-file-drop-accept .sky-avatar-wrapper-size-medium,.sky-file-drop-reject .sky-avatar-wrapper-size-medium{padding:calc(var(--sky-override-avatar-wrapper-padding-md, var(--sky-space-inset-thumbnail_matte-m)) - var(--sky-override-avatar-wrapper-drop-border-width, var(--sky-border-width-input-hover)))}.sky-file-drop-accept .sky-avatar-wrapper-size-small,.sky-file-drop-reject .sky-avatar-wrapper-size-small{padding:calc(var(--sky-override-avatar-wrapper-padding-sm, var(--sky-space-inset-thumbnail_matte-s)) - var(--sky-override-avatar-wrapper-drop-border-width, var(--sky-border-width-input-hover)))}sky-file-drop:hover .sky-avatar-wrapper{border:var(--sky-override-avatar-wrapper-drop-border-hover, var(--sky-border-width-input-hover) solid var(--sky-color-border-input-hover));padding:calc(var(--sky-override-avatar-wrapper-padding, var(--sky-space-inset-thumbnail_matte-l)) - var(--sky-border-width-input-hover))}sky-file-drop:hover .sky-avatar-wrapper.sky-avatar-wrapper-size-medium{padding:calc(var(--sky-override-avatar-wrapper-padding-md, var(--sky-space-inset-thumbnail_matte-m)) - var(--sky-border-width-input-hover))}sky-file-drop:hover .sky-avatar-wrapper.sky-avatar-wrapper-size-small{padding:calc(var(--sky-override-avatar-wrapper-padding-sm, var(--sky-space-inset-thumbnail_matte-s)) - var(--sky-border-width-input-hover))}sky-file-drop:active .sky-avatar-wrapper,sky-file-drop:focus-within .sky-avatar-wrapper{border:var(--sky-override-avatar-wrapper-drop-border-active, var(--sky-border-width-input-active) solid var(--sky-color-border-input-active));padding:calc(var(--sky-override-avatar-wrapper-padding, var(--sky-space-inset-thumbnail_matte-l)) - var(--sky-border-width-input-active))}sky-file-drop:active .sky-avatar-wrapper.sky-avatar-wrapper-size-medium,sky-file-drop:focus-within .sky-avatar-wrapper.sky-avatar-wrapper-size-medium{padding:calc(var(--sky-override-avatar-wrapper-padding-md, var(--sky-space-inset-thumbnail_matte-m)) - var(--sky-border-width-input-active))}sky-file-drop:active .sky-avatar-wrapper.sky-avatar-wrapper-size-small,sky-file-drop:focus-within .sky-avatar-wrapper.sky-avatar-wrapper-size-small{padding:calc(var(--sky-override-avatar-wrapper-padding-sm, var(--sky-space-inset-thumbnail_matte-s)) - var(--sky-border-width-input-active))}sky-file-drop:focus-within:not(:active) .sky-avatar-wrapper{box-shadow:var(--sky-override-avatar-wrapper-drop-box-shadow-focus, none)}\n"] }]
        }], ctorParameters: () => [{ type: i0.ElementRef }, { type: SkyAvatarAdapterService }], propDecorators: { src: [{
                type: Input
            }], name: [{
                type: Input
            }], size: [{
                type: Input
            }] } });
function getInitial(name) {
    return name.charAt(0).toUpperCase();
}

const MAX_FILE_SIZE_DEFAULT = 512000;
class SkyAvatarComponent {
    /**
     * Whether users can change the image. To select a different image,
     * users click the image or drag another image on top of it,
     * much like the `sky-file-drop` component in the
     * [file attachment module](https://developer.blackbaud.com/skyux/components/file-attachments/file-attachment).
     * @default false
     */
    set canChange(value) {
        this.#_canChange = !!value;
    }
    get canChange() {
        return this.#_canChange;
    }
    /**
     * The name of the record that the avatar represents.
     * If the `src` property does not specify an image, the component displays
     * initials from the first and last words in the name. To ensure
     * that the component extracts the correct initials, specify a name with no prefix
     * or suffix, or just specify initials with a space between them. This property is
     * not required, but the component requires either the `name` or `src` property.
     */
    set name(value) {
        this.#_name = value;
    }
    get name() {
        return this.#_name;
    }
    /**
     * The image to identify a record. This property is
     * not required, but the component requires either the `name` or `src` property.
     */
    set src(value) {
        this.#_src = value;
    }
    get src() {
        return this.#_src;
    }
    #_canChange;
    #_name;
    #_src;
    #errorService;
    #fileSizePipe;
    #resourcesService;
    #defaultInputProvider;
    constructor(errorService, fileSizePipe, resourcesService) {
        /**
         * The maximum file size for the image in bytes.
         * @default 512000 bytes
         */
        this.maxFileSize = MAX_FILE_SIZE_DEFAULT;
        /**
         * Emits a `SkyFileItem` object when the image is updated.
         */
        this.avatarChanged = new EventEmitter();
        this.#_canChange = false;
        this.#defaultInputProvider = inject(SkyDefaultInputProvider, { optional: true });
        this.#errorService = errorService;
        this.#fileSizePipe = fileSizePipe;
        this.#resourcesService = resourcesService;
        this.sizeDefault = this.#defaultInputProvider?.getValue('avatar', 'size');
    }
    photoDrop(result) {
        /* sanity check */
        /* istanbul ignore else */
        if (result.files && result.files.length > 0) {
            this.avatarChanged.emit(result.files[0]);
        }
        else if (result.rejectedFiles && result.rejectedFiles.length > 0) {
            this.#handleError(result.rejectedFiles);
        }
    }
    #handleError(rejectedFiles) {
        const rejectedFile = rejectedFiles[0];
        if (rejectedFile.errorType === 'maxFileSize') {
            const title = this.#getString('skyux_avatar_error_too_large_title');
            const description = this.#getString('skyux_avatar_error_too_large_description', this.#maxFileSizeText());
            this.#openErrorModal(title, description);
        }
        else if (rejectedFile.errorType === 'fileType') {
            const title = this.#getString('skyux_avatar_error_not_image_title');
            const description = this.#getString('skyux_avatar_error_not_image_description');
            this.#openErrorModal(title, description);
        }
    }
    #maxFileSizeText() {
        return this.#fileSizePipe.transform(this.maxFileSize);
    }
    #openErrorModal(title, description) {
        const config = {
            errorTitle: title,
            errorDescription: description,
            errorCloseText: this.#getString('skyux_avatar_errormodal_ok'),
        };
        this.#errorService.open(config);
    }
    #getString(key, ...args) {
        // TODO: Need to implement the async `getString` method in a breaking change.
        return this.#resourcesService.getStringForLocale({ locale: 'en-US' }, key, ...args);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: SkyAvatarComponent, deps: [{ token: i1.SkyErrorModalService }, { token: i2.SkyFileSizePipe }, { token: i3$1.SkyLibResourcesService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.2.14", type: SkyAvatarComponent, isStandalone: false, selector: "sky-avatar", inputs: { canChange: "canChange", name: "name", src: "src", maxFileSize: "maxFileSize", size: "size" }, outputs: { avatarChanged: "avatarChanged" }, ngImport: i0, template: "<div class=\"sky-avatar\">\n  @if (canChange) {\n    <div class=\"sky-avatar-file-drop\">\n      <sky-file-drop\n        [acceptedTypes]=\"'image/*'\"\n        [fileUploadAriaLabel]=\"\n          src\n            ? ('skyux_avatar_upload_change_aria_label' | skyLibResources: name)\n            : ('skyux_avatar_upload_new_aria_label' | skyLibResources: name)\n        \"\n        [multiple]=\"false\"\n        [maxFileSize]=\"maxFileSize\"\n        [multiple]=\"false\"\n        (filesChanged)=\"photoDrop($event)\"\n      >\n        <ng-container *ngTemplateOutlet=\"innerTemplate\" />\n      </sky-file-drop>\n    </div>\n  } @else {\n    <div>\n      <ng-container *ngTemplateOutlet=\"innerTemplate\" />\n    </div>\n  }\n</div>\n\n<ng-template #innerTemplate>\n  <sky-avatar-inner\n    [name]=\"name\"\n    [size]=\"size ?? (sizeDefault | async) ?? 'large'\"\n    [src]=\"src\"\n  />\n</ng-template>\n", styles: [".sky-avatar:not(.sky-theme-modern *){--sky-override-avatar-file-drop-focus-outline: auto}.sky-avatar .sky-file-drop-col{flex-basis:initial}.sky-avatar .sky-file-drop:focus{outline:var(--sky-override-avatar-file-drop-focus-outline, none)}\n"], dependencies: [{ kind: "directive", type: i4.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "component", type: i2.λ8, selector: "sky-file-drop", inputs: ["fileUploadAriaLabel", "linkUploadAriaLabel", "linkUploadHintText", "minFileSize", "maxFileSize", "multiple", "validateFn", "acceptedTypes", "acceptedTypesErrorMessage", "noClick", "allowLinks", "labelText", "labelHidden", "hintText", "required", "helpPopoverContent", "helpPopoverTitle", "stacked", "helpKey"], outputs: ["filesChanged", "linkInputBlur", "linkChanged"] }, { kind: "component", type: SkyAvatarInnerComponent, selector: "sky-avatar-inner", inputs: ["src", "name", "size"] }, { kind: "pipe", type: i4.AsyncPipe, name: "async" }, { kind: "pipe", type: i3$1.SkyLibResourcesPipe, name: "skyLibResources" }], encapsulation: i0.ViewEncapsulation.None }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: SkyAvatarComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sky-avatar', encapsulation: ViewEncapsulation.None, standalone: false, template: "<div class=\"sky-avatar\">\n  @if (canChange) {\n    <div class=\"sky-avatar-file-drop\">\n      <sky-file-drop\n        [acceptedTypes]=\"'image/*'\"\n        [fileUploadAriaLabel]=\"\n          src\n            ? ('skyux_avatar_upload_change_aria_label' | skyLibResources: name)\n            : ('skyux_avatar_upload_new_aria_label' | skyLibResources: name)\n        \"\n        [multiple]=\"false\"\n        [maxFileSize]=\"maxFileSize\"\n        [multiple]=\"false\"\n        (filesChanged)=\"photoDrop($event)\"\n      >\n        <ng-container *ngTemplateOutlet=\"innerTemplate\" />\n      </sky-file-drop>\n    </div>\n  } @else {\n    <div>\n      <ng-container *ngTemplateOutlet=\"innerTemplate\" />\n    </div>\n  }\n</div>\n\n<ng-template #innerTemplate>\n  <sky-avatar-inner\n    [name]=\"name\"\n    [size]=\"size ?? (sizeDefault | async) ?? 'large'\"\n    [src]=\"src\"\n  />\n</ng-template>\n", styles: [".sky-avatar:not(.sky-theme-modern *){--sky-override-avatar-file-drop-focus-outline: auto}.sky-avatar .sky-file-drop-col{flex-basis:initial}.sky-avatar .sky-file-drop:focus{outline:var(--sky-override-avatar-file-drop-focus-outline, none)}\n"] }]
        }], ctorParameters: () => [{ type: i1.SkyErrorModalService }, { type: i2.SkyFileSizePipe }, { type: i3$1.SkyLibResourcesService }], propDecorators: { canChange: [{
                type: Input
            }], name: [{
                type: Input
            }], src: [{
                type: Input
            }], maxFileSize: [{
                type: Input
            }], size: [{
                type: Input
            }], avatarChanged: [{
                type: Output
            }] } });

class SkyAvatarModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: SkyAvatarModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "19.2.14", ngImport: i0, type: SkyAvatarModule, declarations: [SkyAvatarInnerComponent, SkyAvatarComponent], imports: [CommonModule,
            SkyAvatarResourcesModule,
            SkyErrorModule,
            SkyFileAttachmentsModule,
            SkyThemeModule], exports: [SkyAvatarComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: SkyAvatarModule, providers: [SkyFileSizePipe], imports: [CommonModule,
            SkyAvatarResourcesModule,
            SkyErrorModule,
            SkyFileAttachmentsModule,
            SkyThemeModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: SkyAvatarModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [SkyAvatarInnerComponent, SkyAvatarComponent],
                    imports: [
                        CommonModule,
                        SkyAvatarResourcesModule,
                        SkyErrorModule,
                        SkyFileAttachmentsModule,
                        SkyThemeModule,
                    ],
                    providers: [SkyFileSizePipe],
                    exports: [SkyAvatarComponent],
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { SkyAvatarModule, SkyAvatarComponent as λ1 };
//# sourceMappingURL=skyux-avatar.mjs.map
